<?php

require_once( $_SERVER['DOCUMENT_ROOT'] . '/classes/clutch-class.php' );

$sample_hunter_data = '{"code":1,"response":{"collection":[{"_distance":"6.425","_distanceuom":"mile","clientkey":"10040098|1000|01|00","uid":-1477425895,"hdid":"DEPRECATED","date":"07\/04\/2023","name":"Ambassador Blind N\' Shutter Inc","address1":"1048 Independent Ave","address2":"Ste A111","city":"Grand Junction","state":"CO","province":null,"postalcode":"81505-6175","country":"US","phone":"(970) 523-4566","shopathome":"S","lead_sms_phone":"970-210-4794","rank":"C","request_a_consultation":"true","lead_sms_notification":"true","email":"davedeters@hotmail.com","website":null,"hd_website":"www.ambassadorblindsgj.com","hd_website2":"www.ambassadorblindsgj.com","lead_email":"pattydeters@msn.com, davedeters@hotmail.com","galleryimage":null,"criteria_1":null,"criteria_2":null,"criteria_3":null,"criteria_4":"Centurion","hours":"M-F: 8:00 am - 4:00 pm, Sat: Closed, Sun: Closed","fax":null,"icon":"default","latitude":39.0820665,"longitude":-108.5813812,"hours_fr":"LUN-VEN: 08H00 - 16H00, SAM: Ferm\u00e9, DIM: Ferm\u00e9","by_appointment_only":"false","dealercommunityactivated":"true","bho":null},{"_distance":"7.020","_distanceuom":"mile","clientkey":"10039799|1000|01|00","uid":-1477426147,"hdid":"DEPRECATED","date":"07\/04\/2023","name":"Good Shepherd Flooring Center","address1":"598 Northgate Dr","address2":"Ste A","city":"Grand Junction","state":"CO","province":null,"postalcode":"81505-6944","country":"US","phone":"(970) 257-1111","shopathome":"B","lead_sms_phone":"(970) 260-2436","rank":"B","request_a_consultation":"true","lead_sms_notification":"true","email":"epiercegsf@gmail.com","website":null,"hd_website":"www.goodshepherdblinds.com","hd_website2":"www.goodshepherdblinds.com","lead_email":"adrianburke2020@gmail.com, bruck.jerry@gmail.com","galleryimage":null,"criteria_1":null,"criteria_2":null,"criteria_3":null,"criteria_4":"Centurion","hours":"M-F: 9:00 am - 5:00 pm, Sat: 10:00 am - 4:00 pm, Sun: Closed","fax":null,"icon":"default","latitude":39.0919,"longitude":-108.58599,"hours_fr":"LUN-VEN: 09H00 - 17H00, SAM: 10H00 - 16H00, DIM: Ferm\u00e9","by_appointment_only":"false","dealercommunityactivated":"true","bho":null},{"_distance":"6.103","_distanceuom":"mile","clientkey":"10039605|1000|01|00","uid":-1477426445,"hdid":"DEPRECATED","date":"07\/04\/2023","name":"Window - Ology Inc","address1":"2846 Hartford Ave","address2":null,"city":"Grand Junction","state":"CO","province":null,"postalcode":"81503-3144","country":"US","phone":"(970) 250-7324","shopathome":"H","lead_sms_phone":null,"rank":"B","request_a_consultation":"false","lead_sms_notification":"false","email":null,"website":null,"hd_website":"www.windowologygrandjunction.com","hd_website2":"www.windowologygrandjunction.com","lead_email":"windowology@msn.com","galleryimage":null,"criteria_1":null,"criteria_2":null,"criteria_3":null,"criteria_4":null,"hours":"M: 12:00 pm - 6:00 pm, T-F: 8:00 am - 6:00 pm, Sat: By Appointment Only, Sun: Closed","fax":null,"icon":"default","latitude":39.0469,"longitude":-108.52533,"hours_fr":"LUN: 12H00 - 18H00, MAR-VEN: 08H00 - 18H00, SAM: Sur rendez-vous uniquement, DIM: Ferm\u00e9","by_appointment_only":"false","dealercommunityactivated":"true","bho":null},{"_distance":"5.926","_distanceuom":"mile","clientkey":"10027011|1000|01|00","uid":-1477426255,"hdid":"DEPRECATED","date":"07\/04\/2023","name":"Gallaghers Flooring","address1":"1100 Pitkin Ave","address2":null,"city":"Grand Junction","state":"CO","province":null,"postalcode":"81501-3638","country":"US","phone":"(970) 245-6959","shopathome":"B","lead_sms_phone":null,"rank":"A","request_a_consultation":"false","lead_sms_notification":"false","email":null,"website":null,"hd_website":null,"hd_website2":null,"lead_email":"char@gallaghersflooring.com, char@gallagherflooring.com","galleryimage":null,"criteria_1":null,"criteria_2":null,"criteria_3":null,"criteria_4":null,"hours":"Please call for store hours.<br\/>(970) 245-6959","fax":null,"icon":"default","latitude":39.06438,"longitude":-108.5543,"hours_fr":"Appelez pour les heures de magasin.<br\/>(970) 245-6959","by_appointment_only":"false","dealercommunityactivated":"true","bho":null},{"_distance":"7.368","_distanceuom":"mile","clientkey":"10036304|1000|01|00","uid":-1477421298,"hdid":"DEPRECATED","date":"07\/04\/2023","name":"Mid Mountain Consulting Llc","address1":"301 30 Rd","address2":null,"city":"Grand Junction","state":"CO","province":null,"postalcode":"81503-2465","country":"US","phone":"(970) 819-5625","shopathome":"B","lead_sms_phone":null,"rank":"A","request_a_consultation":"false","lead_sms_notification":"false","email":null,"website":null,"hd_website":null,"hd_website2":null,"lead_email":"robbsound.rb@gmail.com","galleryimage":null,"criteria_1":null,"criteria_2":null,"criteria_3":null,"criteria_4":null,"hours":"Please call for appointment.<br\/>(970) 819-5625","fax":null,"icon":"default","latitude":39.0466693850913,"longitude":-108.49675119175,"hours_fr":"Veuillez appeler pour une consultation.<br\/>(970) 819-5625","by_appointment_only":"false","dealercommunityactivated":"true","bho":null}],"collectioncount":5,"collectionname":"poi","attributes":{"address":"","city":"GRAND JUNCTION","state":"CO","province":"","country":"US","postalcode":"81507","centerpoint":"-108.615267,38.992875","radius":10,"radiusuom":"mile"},"activeobject":""}}';

class google_scraper extends clutch_class {
	
	public function get_google_place( $query_string ) {
		
		$url = 'https://maps.googleapis.com/maps/api/place/textsearch/json?query=' . urlencode( trim( $query_string ) ) . '+united+states&sensor=true&key=' . GOOGLE_API_KEY;

		$response = $this->do_google_curl( $url );
		
		if( 'OK' != $response->status ) {
			
			return false;
			
		}
		
		$google_data = false;
		
		if(
			@$response->results && is_array( $response->results )
			&& 1 == count( $response->results )
		) {
			
			if(
				@$response->results[0]->business_status
				&& 'operational' == strtolower( $response->results[0]->business_status )
			) {
			
				$google_data = $this->get_google_details( $response->results[0]->place_id );
				
			}
			
		}
		
		return $google_data;
	
	}
	
	public function get_google_details( $place_id ) {
		
		$url = "https://maps.googleapis.com/maps/api/place/details/json?placeid=" . $place_id . "&key=" . GOOGLE_API_KEY;
		
		$response = $this->do_google_curl( $url );
		
		if( 'OK' != $response->status ) {
			return false;
		}
		
		$google_data = false;
		
		if( @$response->result && is_object( $response->result ) ) {
			
			$google_data = array(
				'last_fetched' => date( "Y-m-d H:i:s" )
			);
			
			$google_data['place_id'] = $response->result->place_id;
			$google_data['ambiguous'] = false;
			
			$google_data['status'] = strtolower( $response->result->business_status );
			
			if( @$response->result->types ) {
				$google_data['types'] = $response->result->types;
			}
			
			
			$google_data['review_count'] = @$response->result->user_ratings_total
				? $response->result->user_ratings_total : 0;
			$google_data['rating'] = @$response->result->rating
				? $response->result->rating : 0;
			$google_data['google_photos'] = @$response->result->photos
				? $this->format_google_photos( $response->result->photos ) : '';
			$google_data['google_reviews'] = @$response->result->reviews
				? $response->result->reviews : '';
			
			$google_data['lat'] = $response->result->geometry->location->lat;
			$google_data['lng'] = $response->result->geometry->location->lng;
			
			$google_data['utc_offset'] = @$response->result->utc_offset
				? $response->result->utc_offset : -360;
			
			$google_data['hours'] = @$response->result->opening_hours->weekday_text
				? $response->result->opening_hours->weekday_text
				: '';
			
			if( @$response->result->formatted_phone_number && 10 == strlen( telToTen( $response->result->formatted_phone_number ) ) ) {
				$google_data['phone'] = telToTen( $response->result->formatted_phone_number );
			}
			
			if( @$response->result->website ) {
				$website = explode( "?", $response->result->website );
				$google_data['website'] = $website[0];
			}
			
			if( @$response->result->address_components ) {
				$google_data = $this->format_google_address( $google_data, $response->result->address_components );
			}
			
		}
		
		return $google_data;
		
	}
	
	public function format_google_address( $google_data, $components ) {
		
		foreach( $components as $component ) {
			
			switch( $component->types[0] ) {
					
				case 'subpremise':
					$google_data['address2'] = $component->short_name;
					break;
					
				case 'street_number':
					$google_data['address'] = $component->short_name;
					break;
					
				case 'route':
					$google_data['address'] = isset( $google_data['address'] )
						? $google_data['address'] : '';
					$google_data['address'] .= ' ' . $component->short_name;
					break;
					
				case 'neighborhood':
					$google_data['neighborhood'] = $component->short_name;
					break;
					
				case 'locality':
					$google_data['city'] = $component->short_name;
					break;
					
				case 'administrative_area_level_2':
					$google_data['county'] = $component->short_name;
					break;
					
				case 'administrative_area_level_1':
					$google_data['state'] = $component->short_name;
					break;
					
				case 'country':
					$google_data['country'] = $component->short_name;
					break;
					
				case 'postal_code':
					$google_data['zip'] = $component->short_name;
					break;
						
			}
			
		}
		
		return $google_data;
		
	}
	
	public function format_google_photos( $google_photos ) {
		
		$photos = array();
		
		foreach( $google_photos as $photo ) {
			
			$contributor = $photo->html_attributions[0];
			
			$contributor = preg_replace( "(^\<a href\=\")", "", $contributor );
			$contributor = preg_replace( "(\<\/\>$)", "", $contributor );
			$contributor = preg_replace( "(\"\>)", "|", $contributor );
			
			$contributor = explode( "|", $contributor );
			
			$photo->contributor = array(
				'url' => $contributor[0],
				'name' => @$contributor[1] ? $contributor[1] : 'A Google User'
			);
			unset( $photo->html_attributions );
			
			array_push( $photos, $photo );
			
		}
		
		return $photos;
		
	}
	
	public function do_google_curl( $url ) {
		
		$ch = curl_init();

		curl_setopt( $ch, CURLOPT_URL, $url );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );

		$response = curl_exec( $ch );

		curl_close ( $ch );

		return json_decode( $response );
		
	}
	
	public function geo_code( $query_string ) {
		
		$url = 'https://maps.googleapis.com/maps/api/place/textsearch/json?query=' . urlencode( trim( $query_string ) ) . '+united+states&sensor=true&key=' . GOOGLE_API_KEY;

		$response = $this->do_google_curl( $url );
		
		if( 'OK' != $response->status ) {
			
			return false;
			
		}
		
		return $response;
		
	}
	
}

class clutch_scraper extends clutch_class {
	
	public $locations_inserted = 0, $locations_updated = 0;
	
	public function format_dealer_value( $key, $value ) {
		
		switch( $key ) {
			case 'phone':
				$scrubbed = telToTen( $value );
				break;
				
			case 'website':
				
				$parts = explode( "?", $value );
				
				$scrubbed = $parts[0];
				
				break;
				
			case 'hours':
				$scrubbed = $value;
				break;
				
			case 'country':
				$scrubbed = strtoupper( $value );
				break;
				
			case 'state':
				$scrubbed = strtoupper( $value );
				break;
				
			case 'email':
				$scrubbed = strtolower( $value );
				break;
				
			case 'location_name':
				$scrubbed = $value;
				$scrubbed = preg_replace( "([\,]? Inc[\.]?)", "", ucwords( strtolower( $scrubbed ) ) );
				$scrubbed = preg_replace( "([\,]? Llc[\.]?)", "", ucwords( strtolower( $scrubbed ) ) );
				$scrubbed = preg_replace( "(Aaa)", "AAA", ucwords( strtolower( $scrubbed ) ) );
				
				$parts = explode( "-", $scrubbed );
				
				foreach( $parts as $k => $part ) {
					$parts[ $k ] = ucwords( strtolower( $part ) );
				}
				
				$scrubbed = implode( "-", $parts );
				
				break;
				
			default:
				$scrubbed = ucwords( strtolower( $value ) );
				break;
		}
		
		if(
			null == strtolower( $scrubbed )
			|| 'null' == strtolower( $scrubbed )
			|| '' == strtolower( $scrubbed )
		) {
			$scrubbed = '';
		}
		
		return $scrubbed;
		
	}
	
	function store_google_arrays( $which, $array, $location_id ) {
		
		$db_handler = new db_handler;
		
		// Insert Google Photos
			
		if( ! is_string( $array ) ) {
			$array = json_encode( $array );
		}

		$sql = "
			INSERT INTO `google_" . $which . "` (`location_id`,`google_" . $which . "`,`last_run`)
			VALUES (
				" . $location_id . "," .
				"'" . $db_handler->escape_string( $array ) . "'," .
				"'" . date( "Y-m-d H:i:s" ) . "'
			)
			ON DUPLICATE KEY UPDATE
				`google_" . $which . "` = '" . $db_handler->escape_string( $array ) . "',
				`last_run` = '" . date( "Y-m-d H:i:s" ) . "'
		";

		$db_handler->run_query( $sql, false );
		if( @$db_handler->errors ) {
			$this->log_error( $db_handler->errors );
		}

	}
	
	public function merge_google_data( $location, $google_data ) {
		
		$db_handler = new db_handler;
		
		if( @$google_data['google_photos'] ) {
			$this->store_google_arrays( 'photos', $google_data['google_photos'], $location['location_id'] );
		}
		
		if( @$google_data['google_reviews'] ) {
			$this->store_google_arrays( 'reviews', $google_data['google_reviews'], $location['location_id'] );
		}
		
		$google_overrides = array(
			'location_name',
			'lat',
			'lng',
			'address',
			'address2',
			'neighborhood',
			'city',
			'county',
			'state',
			'country',
			'zip',
			'utc_offset',
			'hours',
			'phone',
			'website',
			'google_photos',
			'google_reviews',
		);
		
		$location_updates = array(
			'google_scraped_date' => date( "Y-m-d H:i:s" ),
			'google_scraped' => 1
		);
		$detail_updates = array();
		
		foreach( $google_overrides as $key ) {
			
			if( isset( $google_data[ $key ] ) ) {
				
				switch( $key ) {

					case 'lat':
						$location_updates[ $key ] = $google_data[ $key ];
						break;

					case 'lng':
						$location_updates[ $key ] = $google_data[ $key ];
						break;
						
					case 'google_photos':
						// $location[ $key ] = $google_data[ $key ];
						break;

					case 'google_reviews':
						// $location[ $key ] = $google_data[ $key ];
						break;
						
					default:
						
						$detail_updates[ $key ] = $google_data[ $key ];
						
						break;
				}
				
				unset( $google_data[ $key ] );
				
			}

		}
		
		
		$detail_updates['google_data'] = json_encode( $google_data );

		$detail_sql = '';
		foreach( $detail_updates as $k => $v ) {
			$detail_sql .= '' != $detail_sql ? "," : "";
			
			if( is_array( $v ) || is_object( $v ) ) {
				$v = json_encode( $v );
			}
			
			$detail_sql .= "\r\n" . "`" . $k . "` = '" . $db_handler->escape_string( $v ) . "'";
		}
		
		$detail_sql = "UPDATE `awc_location_details` SET " . $detail_sql . " WHERE `location_id` = " . $location['location_id'];
		
		$db_handler->run_query( $detail_sql, false );
		
		$location_sql = '';
		foreach( $location_updates as $k => $v ) {
			$location_sql .= '' != $location_sql ? "," : "";
			
			if( is_array( $v ) || is_object( $v ) ) {
				$v = json_encode( $v );
			}
			
			$location_sql .= "\r\n" . "`" . $k . "` = '" . $db_handler->escape_string( $v ) . "'";
		}
		
		$location_sql = "UPDATE `awc_locations` SET " . $location_sql . " WHERE `location_id` = " . $location['location_id'];
		
		$db_handler->run_query( $location_sql, false );
		
		return $location;
	}
	
	public function parse_scraped_data( $location, $brand_data ) {
		
		$dealer = array(
			'claimed' => 0
		);
		$location_name = '';
		
		foreach( $location as $key => $value ) {
			
			if( $key == $brand_data['name-key'] ) {
				$location_name = $this->format_dealer_value( 'location_name', preg_replace( "(\(net\))", "", $value ) );
			}
			
			if( $mapped = $this->map_dealer_field( $key ) ) {
				
				if( 'hunter_data' == $mapped ) {
					
					$dealer['hunter_data'] = @$dealer['hunter_data'] && is_array( $dealer['hunter_data'] )
						? $dealer['hunter_data'] : array();
					
					$dealer['hunter_data'][ $key ] = $value;
					
				}
				
				else if( 'graber_data' == $mapped ) {
					
					$dealer['graber_data'] = @$dealer['graber_data'] && is_array( $dealer['graber_data'] )
						? $dealer['graber_data'] : array();
					
					$dealer['graber_data'][ $key ] = $value;
					
				}
				
				else if( 'horizon_data' == $mapped ) {
					
					$dealer['horizon_data'] = @$dealer['horizon_data'] && is_array( $dealer['horizon_data'] )
						? $dealer['horizon_data'] : array();
					
					$dealer['horizon_data'][ $key ] = $value;
					
				}
				
				else if( 'shop_at_home' == $mapped || 'showroom' == $mapped ) {
					if( @$value ) {
						$dealer[ $mapped ] = 1;
					}
					else {
						$dealer[ $mapped ] = 0;
					}
				}
				
				else if( is_string( $value ) ) {
					$dealer[ $mapped ] = $this->format_dealer_value( $mapped, $value );
				}

				else {
					$dealer[ $mapped ] = $value;
				}
			}
			
		}
		
		$dealer['slug'] = clutch_db_case(
			$dealer['location_name'] . ' ' .
			$dealer['city'] . ', ' .
			$dealer['state'] . ' ' . telToTen( $dealer['phone'] )
		);
		
		return array( $dealer['slug'], $dealer );
		
	}
	
	public function check_if_exists( $location ) {
		
		$db_handler = new db_handler;
		
		$sql = "
			SELECT
				l.*,
				d.*
			FROM
				`awc_locations` l,
				`awc_location_details` d
			WHERE
				d.`location_id` = l.`location_id`
				&& l.`slug` LIKE '" . $location['slug'] . "'
			LIMIT 1
			
		";
		
		$results = $db_handler->run_query( $sql, 1 );
		
		if( @$db_handler->errors ) {
			$this->log_error( $db_handler->errors );
		}
		
		if( is_array( $results ) ) {
			
			$jsons = array(
				'google_data',
				'hunter_data',
				'graber_data',
				'horizon_data',
				'hours',
				'brands'
			);
			
			foreach( $results as $k => $v ) {
				
				if( in_array( $k, $jsons ) ) {
					$results[ $k ] = json_decode( $v );
					
					$results[ $k ] = ( array ) $results[ $k ];
				}
			}
			
			return $results;
		}
		
		return false;
		
	}
	
	public function prepare_details_insert( $location, $location_id ) {
		
		$db_handler = new db_handler;
		
		$sql = "
			SELECT DISTINCT( `DATA_TYPE` ) AS `type`, `COLUMN_NAME` AS `key`
			FROM `INFORMATION_SCHEMA`.`COLUMNS`
			WHERE
				`table_schema` = 'awcovere_clutch2'
				&& `table_name` = 'awc_location_details'
				&& `COLUMN_NAME` NOT LIKE 'location_id'
				&& `COLUMN_NAME` NOT LIKE 'scrape_date'
		";
		
		$columns = $db_handler->run_query( $sql, 'all' );
		
		
		$insert = array(
			'columns' => "`location_id`,`scrape_date`",
			'values' => $location_id . ",'" . date( "Y-m-d H:i:s" ) . "'",
			'updates' => ""
		);
		
		foreach( $columns as $column ) {
			
			$insert['columns'] .= '' != $insert['columns'] ? "," : "";
			$insert['values'] .= '' != $insert['values'] ? "," : "";
			$insert['updates'] .= '' != $insert['updates'] ? "," : "";
			
			$insert['columns'] .= "`" . $column['key'] . "`";
			
			switch( $column['type'] ) {
				
				case 'datetime':
					
					if(
						preg_match( "(scrape_date)", $column['key'] )
						&& ! @$location[ $column['key'] ]
					) {
						$value = date( "Y-m-d H:i:s" );
					}
					
					else {
						$value = @$location[ $column['key'] ]
							? "'" . $location[ $column['key'] ] . "'"
							: "'2000-01-01 00:00:00'";
					}
					
					break;
					
				case 'int':
					$value = @$location[ $column['key'] ]
						? intval( $location[ $column['key'] ] )
						: 0;
					break;
					
				case 'bigint':
					$value = @$location[ $column['key'] ]
						? intval( $location[ $column['key'] ] )
						: 0;
					break;
					
				case 'tinyint':
					$value = @$location[ $column['key'] ] ? 1 : 0;
					break;
					
				default:
					
					if( preg_match( "(phone)", $column['key'] ) ) {
						$value = @$location[ $column['key'] ] && 10 == strlen( telToTen( @$location[ $column['key'] ] ) )
							? "'" . telToTen( $location[ $column['key'] ] ) . "'"
							: "''";
					}
					
					else if(
						isset( $location[ $column['key'] ] )
						&& (
							is_object( $location[ $column['key'] ] )
							|| is_array( $location[ $column['key'] ] )
						)
					) {
						$value = "'" . $db_handler->escape_string( json_encode( $location[ $column['key'] ] ) ) . "'";
					}
					
					else {
						$value = isset( $location[ $column['key'] ] )
							?  "'" . $db_handler->escape_string( $location[ $column['key'] ] ) . "'"
							: "''";
					}
					
					break;
					
			}
			
			$insert['values'] .= $value;
			$insert['updates'] .= "`" . $column['key'] . "` = " . $value;

		}
		
		return $insert;
		
	}
	
	public function un_json_location( $location ) {
		
		$jsons = array(
			'google_data',
			'hunter_data',
			'graber_data',
			'horizon_data',
			'hours',
			'brands'
		);
		
		foreach( $location as $k => $v ) {
			if( in_array( $k, $jsons ) ) {
				
				if( is_string( $v ) ) {
					$location[ $k ] = json_decode( $v );
					$location[ $k ] = ( array ) $location[ $k ];
				}
			}
		}
		
		return $location;
		
	}
	
	public function set_scraper_data( $location ) {
		
		$location = $this->un_json_location( $location );
		
		if( isset( $location['hunter_data'] ) ) {
			
			if( is_string( $location['hunter_data'] ) && '' != trim( $location['hunter_data'] ) ) {
				$location['hunter_data'] = json_decode( $location['hunter_data'] );
			}
			
			if( is_array( $location['hunter_data'] ) && 0 < count( $location['hunter_data'] ) ) {
				
				$location['brands'] = @$location['brands'] && is_array( $location['brands'] )
					? $location['brands'] : array();
				
				$location['brands']['hunter'] = 1;
				
				if( !isset( $location['hunter_data']['scraped_name'] ) ) {
					$location['hunter_data']['scraped_name'] = $location['location_name'];
				}
				
			}
			
			if(
				@$location['hunter_data'][ 'hd_website' ]
				&& '' != $location['hunter_data'][ 'hd_website' ]
				&& (
					! @$location['website']
					|| '' == $location['website']
				)
			) {
				$location['website'] = $location['hunter_data'][ 'hd_website' ];
			}
			
		}
		
		if( isset( $location['graber_data'] ) ) {
			
			if( is_string( $location['graber_data'] ) && '' != trim( $location['graber_data'] ) ) {
				$location['graber_data'] = json_decode( $location['graber_data'] );
			}
			
			if( is_array( $location['graber_data'] ) && 0 < count( $location['graber_data'] ) ) {
				
				$location['brands'] = @$location['brands'] && is_array( $location['brands'] )
					? $location['brands'] : array();
				
				$location['brands']['graber'] = 1;
				
				if( !isset( $location['graber_data']['scraped_name'] ) ) {
					$location['graber_data']['scraped_name'] = $location['location_name'];
				}
				
			}
		}
		
		if( isset( $location['horizon_data'] ) ) {
			
			if( is_string( $location['horizon_data'] ) && '' != trim( $location['horizon_data'] ) ) {
				$location['horizon_data'] = json_decode( $location['horizon_data'] );
			}
			
			if( is_array( $location['horizon_data'] ) && 0 < count( $location['horizon_data'] ) ) {
				
				$location['brands'] = @$location['brands'] && is_array( $location['brands'] )
					? $location['brands'] : array();
				
				$location['brands']['horizon'] = 1;
				
				if( !isset( $location['horizon_data']['scraped_name'] ) ) {
					$location['horizon_data']['scraped_name'] = $location['location_name'];
				}
				
			}
		}
		
		return $location;
		
	}
	
	public function merge_location_data( $existing_location, $location ) {
		
		$jsons = array(
			'google_data',
			'hunter_data',
			'graber_data',
			'horizon_data',
			'hours',
			'brands'
		);
		
		foreach( $existing_location as $k => $v ) {
			
			// Don't bother if location[ $k ] doesn't exist
			if( @$location[ $k ] ) {

				if( in_array( $k, $jsons ) ) {

					if( ! is_array( $v ) && ! is_object( $v ) ) {
						$existing_location[ $k ] = json_decode( $v );
					}

					if( is_object( $existing_location[ $k ] ) ) {
						$existing_location[ $k ] = (array) $existing_location[ $k ];
					}
					else if( is_string( $existing_location[ $k ] ) ) {
						$existing_location[ $k ] = explode( ",", $existing_location[ $k ] );
					}
					else {
						$existing_location[ $k ] = array();
					}
					foreach( $existing_location[ $k ] as $kk => $vv ) {
						if( is_string( $vv ) ) {
							$existing_location[ $k ][ $kk ] = trim( $vv );
						}
					}



					if( is_object( $location[ $k ] ) ) {
						$location[ $k ] = (array) $location[ $k ];
					}
					else if( is_string( $location[ $k ] ) ) {
						$location[ $k ] = explode( ",", $location[ $k ] );
					}
					else if( ! @$location[ $k ] ) {
						$location[ $k ] = array();
					}
					foreach( $location[ $k ] as $kk => $vv ) {
						if( is_string( $vv ) ) {
							$location[ $k ][ $kk ] = trim( $vv );
						}
					}


					if( is_array( $location[ $k ] ) ) {
						foreach( $location[ $k ] as $kk => $vv ) {
							if( ! isset( $existing_location[ $k ][ $kk ] ) || '' == $existing_location[ $k ][ $kk ] ) {
								$existing_location[ $k ][ $kk ] = $vv;
							}
						}
					}

				}

				else if(
					is_string( $v )
					&& '' == $v
					&& $location[ $k ] != ''
				) {
					$existing_location[ $k ] = $location[ $k ];
				}
				
				else if(
					is_int( $v )
					&& $v == 0
					&& 0 != intval( $location[ $k ] )
				) {
					
					$existing_location[ $k ] = intval( $location[ $k ] );
				}
				
				else if(
					is_float( $v )
					&& $v != 0
					&& 0 != floatval( $location[ $k ] )
				) {
					$existing_location[ $k ] = floatval( $location[ $k ] );
				}
				
				else if(
					is_array( $v )
					&& is_array( $location[ $k ] )
				) {
					foreach( $location[ $k ] as $kk => $vv ) {
						$existing_location[ $k ][ $kk ] = $vv;
					}
					
				}
				else {
					$existing_location[ $k ] = $location[ $k ];
				}
				
			}

		}
		
		
		return $existing_location;
		
	}
	
	public function store_location( $location ) {
		
		$db_handler = new db_handler;
	
		$existing_location = $this->check_if_exists( $location );
		$location = $this->set_scraper_data( $location );
		
		if( @$existing_location ) {
			
			$location = $this->merge_location_data( $existing_location, $location );
			$this->locations_updated++;
			
		}
		else {
		
			// Insert the location
			$sql = "
				INSERT INTO `awc_locations` (
					`slug`,
					`lat`,
					`lng`
				) VALUES (
					'" . $db_handler->escape_string( $location['slug'] ) . "',
					" . $location['lat'] . ",
					" . $location['lng'] . "
				)
				ON DUPLICATE KEY UPDATE
					`slug` = '" . $db_handler->escape_string( $location['slug'] ) . "',
					`lat` = " . $location['lat'] . ",
					`lng` = " . $location['lng'] . "
			";
			$location['location_id'] = $db_handler->run_query( $sql, 'id' );
			
			$this->locations_inserted++;
			
			if( @$db_handler->errors ) {
				$this->log_error( $db_handler->errors );
			}
			
			
		}
		
		$details_insert = $this->prepare_details_insert( $location, $location['location_id'] );

		$sql = "
			INSERT INTO `awc_location_details` (" . $details_insert['columns'] . ") VALUES (" . $details_insert['values'] . ")
			ON DUPLICATE KEY UPDATE " . $details_insert['updates'] . "
		";
		
		$db_handler->run_query( $sql, false );
		if( @$db_handler->errors ) {
			$this->log_error( $db_handler->errors );
		}
		
		return $location;
		
	}
	
	public function process_list( $locations, $fetched_locations, $brand_data ) {
		
		
		$added = 0;
		foreach( $fetched_locations as $location ) {
			
			
			$added++;
			
			if( 100 <= $added ) {
				return $locations;
			}
			
			list( $slug, $dealer ) = $this->parse_scraped_data( $location, $brand_data );
			
			
			$stored = $this->store_location( $dealer );
			
		}
		
		return $locations;
		
	}
	
}

class hd_scraper extends clutch_scraper {
	
	public $brands = array(
		'hunter' => array(
			'name' => 'hunter',
			'name-key' => 'name'
		)
	);
	
	public function __construct( $geo_query ) {
		
		$this->geo_query = $geo_query;
		
	}
	
	public function find_dealers( $locations ) {
		
		$fetched_locations = $this->send_location_request();
		
		$locations = $this->process_list( $locations, $fetched_locations, $this->brands['hunter'] );
		
		
		
		return $locations;
		
	}
	
	public function send_location_request() {
		
		global $sample_hunter_data;
		
		$api_url = "https://www.hunterdouglas.com/content/hd-consumer/requests/forms/locator.hdform.json?searchradius=" . $this->geo_query['radius'] . "&country=US&addressline=" . $this->geo_query['address'] . "&lang=en-us";
		
		$ch = curl_init();
		
		curl_setopt( $ch, CURLOPT_URL, $api_url );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
		
		$result = curl_exec( $ch );
		
		$statusCode = curl_getinfo( $ch, CURLINFO_HTTP_CODE );
		
		curl_close($ch);
		
		$response = json_decode( $result );
		
		if( is_array( $response->response->collection ) && 0 < count( $response->response->collection ) ) {
			$log_file = $_SERVER['DOCUMENT_ROOT'] . '/scrapes/hunter-' . $_POST['zip'] . '-' . date( "Y-m-d_H-i-s" ) . '.json';
			file_put_contents( $log_file, json_encode( $response ) );
		}
		
		return $response->response->collection;
		
		
	}
	
	public function map_dealer_field( $key ) {
		
		$field_map = array(

			// Hunter
			'name' => 'location_name',
			'address1' => 'address',
			'address2' => 'address2',
			'city' => 'city',
			'state' => 'state',
			'province' => 'state',
			'postalcode' => 'zip',
			'country' => 'country',
			'phone' => 'phone',
			'shopathome' => 'shop_at_home',
			'lead_sms_notification' => 'do_lead_sms',
			'lead_sms_phone' => 'lead_sms_phone',
			'rank' => 'hd_rank',
			'email' => 'email',
			'lead_email' => 'lead_email',
			'website' => 'website',
			
			'hours' => 'hours',
			'latitude' => 'lat',
			'longitude' => 'lng',
			'by_appointment_only' => 'by_appointment_only',

			
			'hd_website' => 'hunter_data',
			'hd_website2' => 'hunter_data',
			'criteria_1' => 'hunter_data',
			'criteria_2' => 'hunter_data',
			'criteria_3' => 'hunter_data',
			'criteria_4' => 'hunter_data',
			
			
		);
		
		if( isset( $field_map[ $key ] ) ) {
			return $field_map[ $key ];
		}
		
		else {
			return false;
		}
	}
	
}

class springs_scraper extends clutch_scraper {

	public $brands = array(
		'graber' => array(
			'name' => 'graber',
			'api_url' => 'https://www.graberblinds.com/api/service/getlocations',
			'brand_code' => 'G',
			'response-key' => 'get-locations-response',
			'name-key' => 'business-name'
		),
		'horizon' => array(
			'name' => 'horizon',
			'api_url' => 'https://www.horizonshades.com/getlocations',
			'brand_code' => 'H',
			'response-key' => 'getlocationsresponse',
			'name-key' => 'businessname'
		)
	);
	
	public function __construct( $geo_query ) {
		
		$this->geo_query = $geo_query;
		
	}

	public function find_dealers( $locations ) {
		
		foreach( $this->brands as $brand => $brand_data ) {
			
			$response_element = $brand_data['response-key'];

			$api_url = $brand_data['api_url'];

			$post_data = "brandcode=" . $brand_data['brand_code'] . "&countrycode=US&latitude=" .
				$this->geo_query['lat'] . "&longitude=" .
				$this->geo_query['lng'] . "&address=" .
				$this->geo_query['address'] . "&radius=" .
				$this->geo_query['radius'] . "&results=50&netsales=5000";

			$response = $this->send_location_request( $api_url, $post_data );

			$fetched_locations = $response->$response_element->locations;

			
			if( is_array( $fetched_locations ) && 0 < count( $fetched_locations ) ) {
				$log_file = $_SERVER['DOCUMENT_ROOT'] . '/scrapes/' . $brand_data['name'] . '-' . $_POST['zip'] . '-' . date( "Y-m-d_H-i-s" ) . '.json';
				file_put_contents( $log_file, json_encode( $fetched_locations ) );
			}
			
			$locations = $this->process_list( $locations, $fetched_locations, $brand_data );
			
		}
		
		return array(); // $locations;
		
	}
	
	public function send_location_request( $api_url, $post_data ) {
		
		$ch = curl_init();
		$headers  = ['Content-Type: application/x-www-form-urlencoded'];

		curl_setopt( $ch, CURLOPT_URL, $api_url );
		curl_setopt( $ch, CURLOPT_POST, 1 );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
		curl_setopt( $ch, CURLOPT_POSTFIELDS, $post_data );
		curl_setopt( $ch, CURLOPT_HTTPHEADER, $headers );
		$result     = curl_exec ( $ch );
		$statusCode = curl_getinfo( $ch, CURLINFO_HTTP_CODE );
		
		return json_decode( $result );

	}

	public function map_dealer_field( $key ) {
		
		$field_map = array(

			// Graber
			'business-name' => 'location_name',
			'address-line1' => 'address',
			'address-line2' => 'address2',
			'city' => 'city',
			'state' => 'state',
			'postal-code' => 'zip',
			'latitude' => 'lat',
			'longitude' => 'lng',
			'country' => 'country',
			'phone-number' => 'phone',
			'email' => 'email',
			'website' => 'website',
			'business-hours' => 'hours',
			'design-center' => 'showroom',
			'shop-at-home-indicator' => 'shop_at_home',
			'premium-partner' => 'graber_data',
			'dealer-type' => 'graber_data',

			// Horizon
			'businessname' => 'location_name',
			'addressline1' => 'address',
			'addressline2' => 'address2',
			'postalcode' => 'zip',
			'phonenumber' => 'phone',
			'businesshours' => 'hours',
			'shopathomeindicator' => 'shop_at_home',
			'premiumpartner' => 'horizon_data'

		);
		
		if( isset( $field_map[ $key ] ) ) {
			return $field_map[ $key ];
		}
		
		else {
			return false;
		}
	}
	
}