<?php

define("CLUTCH_DATABASE", "awc_dealers");
define("CLUTCH_DB_USER", "awc_dealers_admin");
define("CLUTCH_DB_PASSWORD", "cpSiL@(h@N~=");

class clutchConnection {
	public function logErrors($message, $error, $query) {
		$this->errors = isset($this->errors) && is_array($this->errors) ? $this->errors : array();
		$message =
			"<div class=\"error\">" .
				$message . "&nbsp; MySQL said:<br />" .
				$error .
				"<pre>" . $query . "</pre>" .
			"</div>"
		;
		$this->errors[] = $message;
		if( defined("PRINT_ERRORS") && PRINT_ERRORS == true ) {
			print $message;
		}
		return $message;
	}
	public function clearErrors() {
		unset( $this->errors );
	}
	public function connect($whichDB) {
		/**  $whichDB was added for future expansion, but never expanded
		 **  Because many scripts use clutchConnection->connect(false)
		 **  it has been left here
		 */
		$this->connection = mysql_connect("localhost",CLUTCH_DB_USER,CLUTCH_DB_PASSWORD)
			or $this->logErrors("Couldn't connect to server", mysql_error(), "");
		$this->db = mysql_select_db(CLUTCH_DATABASE,$this->connection)
			or $this->logErrors("Couldn't select database.", mysql_error(), "");
		return $this->connection;
	}
	public function runQuery($q, $message) {
		$this->connect(false);
		$query = mysql_query($q)
			or $this->logErrors($message, mysql_error(), $q);
		return $query;
	}
	public function columnInfo($table) {
		$this->connect(false);
		$q = "SHOW COLUMNS FROM " . CLUTCH_DATABASE . "." . mysql_real_escape_string($table);
		$query = $this->runQuery($q, "Failed at clutchConnection->columnInfo(" . $table . ")");
		if( $query ) {
			$c = mysql_num_rows($query);
			if( $c > 0 ) {
				$columns = array();
				for($i=1;$i<=$c;$i++) {
					$row = mysql_fetch_assoc($query);
					$columns[$row['Field']] = $row;
				}
			}
			else $columns = false;
		}
		else $columns = false;
		return $columns;
	}
	public function columnLabels($table) {
		$this->connect(false);
		$columns = array();
		$q = "
			SELECT
				`COLUMN_NAME` 
			FROM
				`INFORMATION_SCHEMA`.`COLUMNS`
			WHERE
				`TABLE_SCHEMA` = '" . CLUTCH_DATABASE . "'
				AND `TABLE_NAME`='" . mysql_real_escape_string($table) . "'
		";
		$query = $this->runQuery($q, "Failed at clutchConnection->checkColumns(" . $table . ")");
		for($i=1;$i<=mysql_num_rows($query);$i++) {
			$row = mysql_fetch_object($query);
			$columns[$row->COLUMN_NAME] = true;
		}
		return $columns;
	}
	public function addColumn($tableName, $columnName, $columnType, $columnLength, $defaultValue) {
		if( trim($columnName) != "" &&  trim($tableName) != "" ) {
			$this->connect(false);
			$lengths = explode(",","char,varchar,int,tinyint,smallint,mediumint,bigint");
			if( in_array($columnType, $lengths) ) {
				$addSQL =
					"ADD COLUMN `" . mysql_real_escape_string($columnName) . "` " . $columnType . "(" . intval($columnLength) . ") NOT NULL"
				;
				$addSQL .= trim($defaultValue) != "" ? " DEFAULT '" . mysql_real_escape_string($defaultValue) . "'" : "";
			}
			elseif( $columnType == "enum" ) {
				$addSQL = "ADD COLUMN `" . mysql_real_escape_string($columnName) . "` enum(" . intval($defaultValue) . ") NOT NULL";
			}
			else {
				$addSQL =  "ADD COLUMN `" . mysql_real_escape_string($columnName) . "` " . mysql_real_escape_string($columnType) . " NOT NULL";
			}
			if( trim($addSQL) != "" ) {
				$q =
					"ALTER TABLE `" . mysql_real_escape_string($tableName) . "` "
					. $addSQL . ";"
				;
				$query = $this->runQuery($q, "Failed at clutchConnection->addColumn(" . $columnName . ", " . $tableName . ")");
				if( $query ) return true;
				else return $this->errors;
			}
		}
	}
	public function buildInsert($object, $table) {
		$inserts = array();
		$this->connect(false);
		$inserts = array(
			"fields" => "",
			"values" => "",
			"updates" => ""
		);
		if( is_array($object->tables[$table]) ) {
			foreach($object->tables[$table] as $field => $v) {
				if( isset($object->$field) ) {
					if( "id" != $field ) {
						$inserts["fields"] .= "`" . $field . "`,";
						$inserts["values"] .= "'" . mysql_real_escape_string($object->$field) . "',";
						$inserts["updates"] .= "`" . $field . "` = '" . mysql_real_escape_string($object->$field) . "',";
					}
					elseif( intval($object->id) >= 1 ) {
						$inserts["fields"] .= "`" . $field . "`,";
						$inserts["values"] .= "'" . mysql_real_escape_string($object->$field) . "',";
						$inserts["updates"] .= "`" . $field . "` = '" . mysql_real_escape_string($object->$field) . "',";
					}
				}
			}
		}
		$q =
			"INSERT INTO `" . mysql_real_escape_string($table) . "`"
			. " (" . rtrim($inserts["fields"],",") . ")"
			. " VALUES (" . rtrim($inserts["values"],",") . ")"
		;
		if( rtrim($inserts["updates"],",") != "" ) {
			$q .=
				" ON DUPLICATE KEY UPDATE"
				. " " . rtrim($inserts["updates"],",") . "
			";
		}
		return $q;
	}
 }

?>