<?php

require_once( $_SERVER['DOCUMENT_ROOT'] . '/clutch-config.php' );
require_once( $_SERVER['DOCUMENT_ROOT'] . '/includes/helper-functions.php' );

require_once( $_SERVER['DOCUMENT_ROOT'] . '/classes/clutch-class.php' );
require_once( $_SERVER['DOCUMENT_ROOT'] . '/classes/db-handler-class.php' );
require_once( $_SERVER['DOCUMENT_ROOT'] . '/classes/scraper-classes.php' );

?>
<!doctype html>
<html>
<head>
<meta charset="UTF-8">
<title>Untitled Document</title>
</head>

<body>
	
<?php

if( @$_POST['zip'] ) {

	echo '<h1>' . $_POST['zip'] . '</h1>';
	
	$zip = $_POST['zip'];
	$radius = 100;

	$google = new google_scraper;
	$google_data = $google->geo_code( $zip );
	
	if( 'OK' == $google_data->status && @$google_data->results ) {

		$geo_query = array(
			'address' => $zip,
			'radius' => $radius,
			'lat' => $google_data->results[0]->geometry->location->lat,
			'lng' => $google_data->results[0]->geometry->location->lng
		);

		// Store the result so we don't have to fetch it again
		$db_handler = new db_handler;
		$sql = "
			INSERT INTO `zip_codes` (
				`zip`,
				`lat`,
				`lng`,
				`last_run`
			) VALUES (
				'" . $db_handler->escape_string( $geo_query['address'] ) . "',
				" . $geo_query['lat'] . ",
				" . $geo_query['lng'] . ",
				'" . date( "Y-m-d H:i:s" ) . "'
			)
			ON DUPLICATE KEY UPDATE
				`zip` = '" . $db_handler->escape_string( $geo_query['address'] ) . "',
				`lat` = " . $geo_query['lat'] . ",
				`lng` = " . $geo_query['lng'] . ",
				`last_run` = '" . date( "Y-m-d H:i:s" ) . "'
		";
		$db_handler->run_query( $sql, false );
		
		$locations = array();

		$hunter = new hd_scraper( $geo_query );
		$locations = $hunter->find_dealers( $locations );

		if( ! @$hunter->errors ) {
			
			$springs = new springs_scraper( $geo_query );
			$locations = $springs->find_dealers( $locations );

			if( @$springs->errors ) {
				echo 'Springs Errors<pre>' . print_r( $springs->errors, 1 ) . '</pre>';
			}
			
		}
		else {
			echo 'Hunter Errors<pre>' . print_r( $hunter->errors, 1 ) . '</pre>';
		}

		echo ( $hunter->locations_inserted + $springs->locations_inserted ) . ' Locations Inserted (' .
			
			$hunter->locations_inserted . ' Hunter Douglas and ' . $springs->locations_inserted . ' Springs)<br><br>' .
			
			( $hunter->locations_updated + $springs->locations_updated ) . ' Locations Updated (' .
			$hunter->locations_updated . ' Hunter Douglas and ' . $springs->locations_updated . ' Springs)<hr>';


	}
	
}
	
	
?>
	
	<form method="post">
		
		<div>
			<label for="zip">Zip Code</label>
			<input type="text" name="zip" value="">
		</div>
		<div><input type="submit" value="Submit"></div>
		
	</form>
	
</body>
</html>